Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# Thread Class Reference

A thread; that is, a lightweight process. More...

Inheritance diagram for Thread:

List of all members.

## Public Member Functions
AsyncTaskBase | getCurrentTask ()
| Returns the task currently executing on this thread (via the AsyncTaskManager), if any, or NULL if the thread is not currently servicing a task.
int | getPipelineStage ()
| Returns the Pipeline stage number associated with this thread.
int | getPstatsIndex ()
| Returns the PStats index associated with this thread, or -1 if no index has yet been associated with this thread.
PyObject | getPythonData ()
| Returns the Python object that was set with set_python_data().
string | getSyncName ()
| Returns the sync name of the thread.
string | getUniqueId ()
| Returns a string that is guaranteed to be unique to this thread, across all processes on the machine, during at least the lifetime of this process.
bool | isJoinable ()
| Returns the value of joinable that was passed to the start() call.
bool | isStarted ()
| Returns true if the thread has been started, false if it has not, or if join() has already been called.
| join ()
| Blocks the calling process until the thread terminates.
| output (ostream out)
| Outputs the Namable.
| outputBlocker (ostream out)
| Writes a description of the mutex or condition variable that this thread is blocked on.
| preempt ()
| Indicates that this thread should run as soon as possible, preemptying any other threads that may be scheduled to run.
| setMinPipelineStage (int min_pipeline_stage)
| Sets this thread's pipeline stage number to at least the indicated value, unless it is already larger.
| setPipelineStage (int pipeline_stage)
| Specifies the Pipeline stage number associated with this thread.
| setPythonData (PyObject python_data)
| Sets an arbitrary Python object that may be associated with this thread object.
bool | start (ThreadPriority priority, bool joinable)
| Starts the thread executing.
## Static Public Member Functions
static Thread | bindThread (string name, string sync_name)
| Returns a new Panda Thread object associated with the current thread (which has been created externally).
static | considerYield ()
| Possibly suspends the current thread for the rest of the current epoch, if it has run for enough this epoch.
static | forceYield ()
| Suspends the current thread for the rest of the current epoch.
static TypeHandle | getClassType ()
static int | getCurrentPipelineStage ()
| Returns the integer pipeline stage associated with the current thread.
static Thread | getCurrentThread ()
| Returns a pointer to the currently-executing Thread object.
static Thread | getExternalThread ()
| Returns a pointer to the "external" Thread object--this is a special Thread object that corresponds to any thread spawned outside of Panda's threading interface.
static Thread | getMainThread ()
| Returns a pointer to the "main" Thread object--this is the Thread that started the whole process.
static bool | isSimpleThreads ()
| Returns true if Panda is currently compiled for "simple threads", which is to say, cooperative context switching only, reducing the need for quite so many critical section protections.
static bool | isThreadingSupported ()
| Returns true if threading support has been compiled in and enabled, or false if no threading is available (and Thread.start() will always fail).
static bool | isTrueThreads ()
| Returns true if a real threading library is available that supports actual OS-implemented threads, or false if the only threading we can provide is simulated user-space threading.
static | prepareForExit ()
| Should be called by the main thread just before exiting the program, this blocks until any remaining thread cleanup has finished.
static | sleep (double seconds)
| Suspends the current thread for at least the indicated amount of time.
static | writeStatus (ostream out)

## Detailed Description

A thread; that is, a lightweight process.

This is an abstract base class; to use it, you must subclass from it and redefine thread_main().

The thread itself will keep a reference count on the Thread object while it is running; when the thread returns from its root function, the Thread object will automatically be destructed if no other pointers are referencing it.

## Member Function Documentation

static Thread bindThread | ( | string | name,
|  | string | sync_name
| ) |  | `[static]`

Returns a new Panda Thread object associated with the current thread (which has been created externally).

This can be used to bind a unique Panda Thread object with an external thread, such as a new Python thread.

It is particularly useful to bind a Panda Thread object to an external thread for the purposes of PStats monitoring. Without this call, each external thread will be assigned the same global ExternalThread object, which means they will all appear in the same PStats graph.

It is the caller's responsibility to save the returned Thread pointer for the lifetime of the external thread. It is an error for the Thread pointer to destruct while the external thread is still in the system.

It is also an error to call this method from the main thread, or twice within a given thread, unless it is given the same name each time (in which case the same pointer will be returned each time).

static considerYield | ( |  | ) | `[static]`

Possibly suspends the current thread for the rest of the current epoch, if it has run for enough this epoch.

This is especially important for the simple thread implementation, which relies on cooperative yields like this.

static forceYield | ( |  | ) | `[static]`

Suspends the current thread for the rest of the current epoch.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

Reimplemented in ExternalThread, MainThread, and PythonThread.

static int getCurrentPipelineStage | ( |  | ) | `[static]`

Returns the integer pipeline stage associated with the current thread.

This is the same thing as get_current_thread()->get_pipeline_stage(), but it may be faster to retrieve in some contexts.

AsyncTaskBase getCurrentTask | ( |  | ) |

Returns the task currently executing on this thread (via the AsyncTaskManager), if any, or NULL if the thread is not currently servicing a task.

static Thread getCurrentThread | ( |  | ) | `[static]`

Returns a pointer to the currently-executing Thread object.

If this is called from the main thread, this will return the same value as get_main_thread().

This will always return some valid Thread pointer. It will never return NULL, even if the current thread was spawned outside of Panda's threading system, although all non-Panda threads will return the exact same Thread pointer.

static Thread getExternalThread | ( |  | ) | `[static]`

Returns a pointer to the "external" Thread object--this is a special Thread object that corresponds to any thread spawned outside of Panda's threading interface.

Note that multiple different threads may share this same pointer.

static Thread getMainThread | ( |  | ) | `[static]`

Returns a pointer to the "main" Thread object--this is the Thread that started the whole process.

int getPipelineStage | ( |  | ) |

Returns the Pipeline stage number associated with this thread.

The default stage is 0 if no stage is specified otherwise. See set_pipeline_stage().

int getPstatsIndex | ( |  | ) |

Returns the PStats index associated with this thread, or -1 if no index has yet been associated with this thread.

This is used internally by the PStatClient; you should not need to call this directly.

PyObject getPythonData | ( |  | ) |

Returns the Python object that was set with set_python_data().

string getSyncName | ( |  | ) |

Returns the sync name of the thread.

This name collects threads into "sync groups", which are expected to run synchronously. This is mainly used for the benefit of PStats; threads with the same sync name can be ticked all at once via the thread_tick() call.

string getUniqueId | ( |  | ) |

Returns a string that is guaranteed to be unique to this thread, across all processes on the machine, during at least the lifetime of this process.

bool isJoinable | ( |  | ) |

Returns the value of joinable that was passed to the start() call.

static bool isSimpleThreads | ( |  | ) | `[static]`

Returns true if Panda is currently compiled for "simple threads", which is to say, cooperative context switching only, reducing the need for quite so many critical section protections.

This is not necessarily the opposite of "true threads", since one possible implementation of simple threads is via true threads with mutex protection to ensure only one runs at a time.

bool isStarted | ( |  | ) |

Returns true if the thread has been started, false if it has not, or if join() has already been called.

static bool isThreadingSupported | ( |  | ) | `[static]`

Returns true if threading support has been compiled in and enabled, or false if no threading is available (and Thread.start() will always fail).

static bool isTrueThreads | ( |  | ) | `[static]`

Returns true if a real threading library is available that supports actual OS-implemented threads, or false if the only threading we can provide is simulated user-space threading.

join | ( |  | ) |

Blocks the calling process until the thread terminates.

If the thread has already terminated, this returns immediately.

Reimplemented in PythonThread.

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

outputBlocker | ( | ostream | out | ) |

Writes a description of the mutex or condition variable that this thread is blocked on.

Writes nothing if there is no blocker, or if we are not in DEBUG_THREADS mode.

preempt | ( |  | ) |

Indicates that this thread should run as soon as possible, preemptying any other threads that may be scheduled to run.

This may not be implemented on every platform.

static prepareForExit | ( |  | ) | `[static]`

Should be called by the main thread just before exiting the program, this blocks until any remaining thread cleanup has finished.

setMinPipelineStage | ( | int | min_pipeline_stage | ) |

Sets this thread's pipeline stage number to at least the indicated value, unless it is already larger.

See set_pipeline_stage().

setPipelineStage | ( | int | pipeline_stage | ) |

Specifies the Pipeline stage number associated with this thread.

The default stage is 0 if no stage is specified otherwise.

This must be a value in the range [0 .. pipeline->get_num_stages() - 1]. It specifies the values that this thread observes for all pipelined data. Typically, an application thread will leave this at 0, but a render thread may set it to 1 or 2 (to operate on the previous frame's data, or the second previous frame's data).

setPythonData | ( | PyObject | python_data | ) |

Sets an arbitrary Python object that may be associated with this thread object.

This is just for the purposes of associated arbitrary Python data with the C++ object; other than managing the reference count, the C++ code does nothing with this object.

static sleep | ( | double | seconds | ) | `[static]`

Suspends the current thread for at least the indicated amount of time.

It might be suspended for longer.

bool start | ( | ThreadPriority | priority,
|  | bool | joinable
| ) |  |

Starts the thread executing.

It is only valid to call this once.

The thread will begin executing its thread_main() function, and will terminate when thread_main() returns.

priority is intended as a hint to the relative importance of this thread. This may be ignored by the thread implementation.

joinable should be set true if you intend to call join() to wait for the thread to terminate, or false if you don't care and you will never call join(). Note that the reference count on the Thread object is incremented while the thread itself is running, so if you just want to fire and forget a thread, you may pass joinable = false, and never store the Thread object. It will automatically destruct itself when it finishes.

The return value is true if the thread is successfully started, false otherwise.

static writeStatus | ( | ostream | out | ) | `[static]`

All Classes Namespaces Functions Variables Enumerations Enumerator Properties